// HHTRXDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HHTRX.h"
#include "HHTRXDlg.h"
#include ".\hhtrxdlg.h"
#include "AboutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CHHTRXDlg dialog



CHHTRXDlg::CHHTRXDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHHTRXDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	 // Initialize all the snap-in functions to NULL
	pGetHHInternalFrequency = (GETHHINTERNALFREQUENCY *)NULL;
	pGetHHTwiddle = (GETHHTWIDDLE *)NULL;
	pEncodeHHDataA = (ENCODEHHDATAA *)NULL;
	pDecodeHHDataA = (DECODEHHDATAA *)NULL;
	pEncodeHHDataW = (ENCODEHHDATAW *)NULL;
	pDecodeHHDataW = (DECODEHHDATAW *)NULL;
	pGetHHToolbar = (GETHHTOOLBAR *)NULL;
	pDoHHCommand = (DOHHCOMMAND *)NULL;
	pLoadHHUserData = (LOADHHUSERDATA *)NULL;
	pSaveHHUserData = (SAVEHHUSERDATA *)NULL;
	pInvokeHHSetup = NULL;
	m_hMode = NULL;
}

CHHTRXDlg::~CHHTRXDlg()
{
	 // Set to NULL to stop any existing processes
	pGetHHInternalFrequency = NULL;
	pGetHHTwiddle = NULL;
	pEncodeHHDataA = NULL;
	pDecodeHHDataA = NULL;
	pEncodeHHDataW = NULL;
	pDecodeHHDataW = NULL;
	pGetHHToolbar = NULL;
	pDoHHCommand = NULL;
	pLoadHHUserData = NULL;
	pSaveHHUserData = NULL;
	 // Close the snap-in
	if( m_hMode )
	{
		::FreeLibrary(m_hMode);
		m_hMode = NULL;
	}
		// Clean up the snap-in allocations
	{
		POSITION Pos = m_SnapinList.GetHeadPosition();
		while(Pos)
		{
			SnapIn *cSnapIn = (SnapIn *)m_SnapinList.GetNext(Pos);
			if( cSnapIn )
				delete cSnapIn;
		}
		m_SnapinList.RemoveAll();
	}
}

void CHHTRXDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_MODULE, m_cbModule);
	DDX_Control(pDX, IDC_EDIT_ENCODE_FILE, m_editEncodeFile);
	DDX_Control(pDX, IDC_EDIT_DECODE_FILE, m_editDecodeFile);
	DDX_Control(pDX, IDC_RICHEDIT_ENCODE, m_reEncode);
	DDX_Control(pDX, IDC_RICHEDIT_DECODE, m_reDecode);
	DDX_Control(pDX, IDC_PROGRESS_ENCODE, m_pcEncode);
	DDX_Control(pDX, IDC_PROGRESS_DECODE, m_pcDecode);
}

BEGIN_MESSAGE_MAP(CHHTRXDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_MODULE, OnCbnSelchangeComboModule)
	ON_BN_CLICKED(IDC_BUTTON_SETUP, OnBnClickedButtonSetup)
	ON_BN_CLICKED(IDC_BUTTON_ENCODE_FILE, OnBnClickedButtonEncodeFile)
	ON_BN_CLICKED(IDC_BUTTON_DECODE_FILE, OnBnClickedButtonDecodeFile)
	ON_BN_CLICKED(IDC_BUTTON_ENCODE, OnBnClickedButtonEncode)
	ON_BN_CLICKED(IDC_BUTTON_DECODE, OnBnClickedButtonDecode)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CHHTRXDlg message handlers

BOOL CHHTRXDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	 // Enumerate the snap-ins
	WIN32_FIND_DATA	w32fd;

	HANDLE hFind = ::FindFirstFile(_T("*.dll"), &w32fd);
	if( hFind )
	{
		do
		{
			HMODULE hInst = ::LoadLibrary(w32fd.cFileName);
			if( hInst )
			{
				typedef BOOL (WINAPI GETHHSETUP)(SNAPINSETUP *);

				GETHHSETUP *pGetHHSetup = (GETHHSETUP *)GetProcAddress(hInst, "GetHHSetup");
				if( pGetHHSetup != NULL )
				{
					SnapIn *cSnapIn = new SnapIn;

					pGetHHSetup(&cSnapIn->m_sisSettings);
					_tcsncpy(cSnapIn->m_szFilename, w32fd.cFileName, sizeof(cSnapIn->m_szFilename)/sizeof(TCHAR));

					m_SnapinList.AddTail(cSnapIn);

					TRACE(L"Detected Soundcard Mode Snap-in %s\n", cSnapIn->m_sisSettings.m_wszName );
					//s_dwEnumModes |= cSnapIn->m_sisSettings.m_dwMode;
				}

				::FreeLibrary(hInst);
			}
		}
		while( ::FindNextFile(hFind, &w32fd) );

		::FindClose(hFind);
	}

	 // Any found?
	if( m_SnapinList.GetCount() <= 0 )
	{
		AfxMessageBox(IDS_NOSNAPINS, MB_OK|MB_ICONEXCLAMATION);
		EndDialog(IDCANCEL);
		return FALSE;
	}

	 // Throw them into the list
	m_cbModule.ResetContent();
	POSITION Pos = m_SnapinList.GetHeadPosition();
	while(Pos)
	{
		SnapIn *cSnapIn = (SnapIn *)m_SnapinList.GetNext(Pos);
#ifdef _UNICODE
		_tcsncpy(cSnapIn->m_szName, cSnapIn->m_sisSettings.m_wszName, sizeof(cSnapIn->m_szName)/sizeof(TCHAR));
#else // _UNICODE
		wcstombs(cSnapIn->m_szName, cSnapIn->m_sisSettings.m_wszName, sizeof(cSnapIn->m_szName)/sizeof(TCHAR));
#endif // _UNICODE
		int iAdd = (int)m_cbModule.AddString(cSnapIn->m_szName);
		m_cbModule.SetItemData(iAdd, (DWORD_PTR)cSnapIn);
	}

	 // Select the last one used
	CString sSelected = AfxGetApp()->GetProfileString(_T("Setup"), _T("Module"), _T(""));
	if( !sSelected.IsEmpty() )
	{
		int iFind = (int)m_cbModule.FindString(-1, sSelected);
		m_cbModule.SetCurSel(iFind);
	}
	else
		m_cbModule.SetCurSel(0);

	 // Process the selection
	OnCbnSelchangeComboModule();

	 // Load the last files used
	sSelected = AfxGetApp()->GetProfileString(_T("Setup"), _T("EncodeFile"), _T(""));
	m_editEncodeFile.SetWindowText(sSelected);
	sSelected = AfxGetApp()->GetProfileString(_T("Setup"), _T("DecodeFile"), _T(""));
	m_editDecodeFile.SetWindowText(sSelected);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHHTRXDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHHTRXDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHHTRXDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CHHTRXDlg::Cleanup(void)
{
	 // Clean up the toolbar
	HWND hWndOld = m_tbToolbar.Detach();
	if( hWndOld )
		::SendMessage(hWndOld, WM_CLOSE, 0, 0);

	 // Get the selected snap-in
	int iSel = (int)m_cbModule.GetCurSel();
	CString sSel;
	m_cbModule.GetLBText(iSel, sSel);

	 // Save it
	AfxGetApp()->WriteProfileString(_T("Setup"), _T("Module"), sSel);

	 // Save the selected files
	m_editEncodeFile.GetWindowText(sSel);
	AfxGetApp()->WriteProfileString(_T("Setup"), _T("EncodeFile"), sSel);
	m_editDecodeFile.GetWindowText(sSel);
	AfxGetApp()->WriteProfileString(_T("Setup"), _T("DecodeFile"), sSel);
}

void CHHTRXDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class
	Cleanup();
	CDialog::OnCancel();
}

void CHHTRXDlg::OnClose()
{
	// TODO: Add your message handler code here and/or call default
	Cleanup();
	CDialog::OnClose();
}

BOOL CHHTRXDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// Check for a snap-in command
	if( pDoHHCommand )
	{
		if( pDoHHCommand(LOWORD(wParam)) )
			return TRUE;
	}

	return CDialog::OnCommand(wParam, lParam);
}

void CHHTRXDlg::OnCbnSelchangeComboModule()
{
	// Process any newly selected snap-in
	int iSel = (int)m_cbModule.GetCurSel();

	if( iSel < 0 ) return;

	SnapIn *cSnapIn = (SnapIn *)m_cbModule.GetItemData(iSel);

	TRACE(_T("Selected Soundcard Mode Snap-in %s\n"), cSnapIn->m_szName );

	 // Can't do this without driver threads
	if( cSnapIn->m_sisSettings.m_bSelfDriven )
	{
		TRACE(_T("Cannot use self driven DLLs\n"));
		AfxMessageBox(IDS_NOSELFDRIVEN, MB_OK);
		pGetHHInternalFrequency = NULL;
		pGetHHTwiddle = NULL;
		pEncodeHHDataA = NULL;
		pDecodeHHDataA = NULL;
		pEncodeHHDataW = NULL;
		pDecodeHHDataW = NULL;
		pGetHHToolbar = NULL;
		pDoHHCommand = NULL;
		pLoadHHUserData = NULL;
		pSaveHHUserData = NULL;
		pInvokeHHSetup = NULL;
	}

	 // Clean up any open snap-in
	if( m_hMode )
	{
		::FreeLibrary(m_hMode);
		m_hMode = NULL;
	}
	 // Open the new one
	m_hMode = ::LoadLibrary(cSnapIn->m_szFilename);
	if( m_hMode )
	{
		 // Initialize it
		typedef BOOL (WINAPI INITHHMODE)(double fFrequency);
		
		INITHHMODE *InitHHMode = (INITHHMODE *)GetProcAddress(m_hMode, "InitHHMode");
		if( InitHHMode )
		{
			(void)InitHHMode(8000.0);
		}
		 // Get all the function pointers
		pGetHHInternalFrequency = (GETHHINTERNALFREQUENCY *)GetProcAddress(m_hMode, "GetHHInternalFrequency");
		pGetHHTwiddle = (GETHHTWIDDLE *)GetProcAddress(m_hMode, "GetHHTwiddle");
		pEncodeHHDataA = (ENCODEHHDATAA *)GetProcAddress(m_hMode, "EncodeHHDataA");
		pDecodeHHDataA = (DECODEHHDATAA *)GetProcAddress(m_hMode, "DecodeHHDataA");
		pEncodeHHDataW = (ENCODEHHDATAW *)GetProcAddress(m_hMode, "EncodeHHDataW");
		pDecodeHHDataW = (DECODEHHDATAW *)GetProcAddress(m_hMode, "DecodeHHDataW");
		pGetHHToolbar = (GETHHTOOLBAR *)GetProcAddress(m_hMode, "GetHHToolbar");
		pDoHHCommand = (DOHHCOMMAND *)GetProcAddress(m_hMode, "DoHHCommand");
		pLoadHHUserData = (LOADHHUSERDATA *)GetProcAddress(m_hMode, "LoadHHUserData");
		pSaveHHUserData = (SAVEHHUSERDATA *)GetProcAddress(m_hMode, "SaveHHUserData");
		pInvokeHHSetup = (INVOKEHHSETUP *)GetProcAddress(m_hMode, "InvokeHHSetup");
	}
	else
	{
		 // Whoops! couldn't open it
		pGetHHInternalFrequency = NULL;
		pGetHHTwiddle = NULL;
		pEncodeHHDataA = NULL;
		pDecodeHHDataA = NULL;
		pEncodeHHDataW = NULL;
		pDecodeHHDataW = NULL;
		pGetHHToolbar = NULL;
		pDoHHCommand = NULL;
		pLoadHHUserData = NULL;
		pSaveHHUserData = NULL;
		pInvokeHHSetup = NULL;
	}

	 // Show the snap-in's toolbar if available
	HWND hWndOld = m_tbToolbar.Detach();
	if( hWndOld && ::IsWindow(hWndOld) )
		::SendMessage(hWndOld, WM_CLOSE, 0, 0);

	if( pGetHHToolbar )
	{
		HWND hWnd = pGetHHToolbar(m_hWnd, 
			TBSTYLE_TRANSPARENT|CBRS_SIZE_FIXED|CBRS_FLYBY, 
			IDC_TOOLBAR);

		m_tbToolbar.Attach(hWnd);

		CRect rectToolbar;
		GetClientRect(rectToolbar);
		rectToolbar.bottom = rectToolbar.top+32;
		rectToolbar.left += 40;

		m_tbToolbar.MoveWindow(rectToolbar, TRUE);
	}
}

 // Do the snap-in's setup
void CHHTRXDlg::OnBnClickedButtonSetup()
{
	if( pInvokeHHSetup )
	{
		(void)pInvokeHHSetup(m_hWnd);
	}
}

 // Browse for the encode filename
void CHHTRXDlg::OnBnClickedButtonEncodeFile()
{
	CString sFilter((LPCTSTR)IDS_WAVFILTER);
	CString sSel;
	
	m_editEncodeFile.GetWindowText(sSel);
	if( sSel.IsEmpty() )
	{
		::GetCurrentDirectory(MAX_PATH, sSel.GetBuffer(MAX_PATH));
		sSel.ReleaseBuffer();
	}
	CFileDialog	fd(TRUE, _T(".wav"), sSel, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, sFilter, this);

	if( fd.DoModal() == IDOK )
	{
		CString sFilename = fd.GetPathName();

		m_editEncodeFile.SetWindowText(sFilename);
	}
}

 // Browse for the decode filename
void CHHTRXDlg::OnBnClickedButtonDecodeFile()
{
	CString sFilter((LPCTSTR)IDS_WAVFILTER);
	CString sSel;
	
	m_editDecodeFile.GetWindowText(sSel);
	if( sSel.IsEmpty() )
	{
		::GetCurrentDirectory(MAX_PATH, sSel.GetBuffer(MAX_PATH));
		sSel.ReleaseBuffer();
	}
	CFileDialog	fd(TRUE, _T(".wav"), sSel, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, sFilter, this);

	if( fd.DoModal() == IDOK )
	{
		CString sFilename = fd.GetPathName();

		m_editDecodeFile.SetWindowText(sFilename);
	}
}

void CHHTRXDlg::OnBnClickedButtonEncode()
{
	// Check for bad pointers
	if( !pEncodeHHDataA && !pEncodeHHDataW )
	{
		TRACE(_T("No Function defined for Encoding!\n"));
		return;
	}
	CString sSel;
	m_editEncodeFile.GetWindowText(sSel);
	if( sSel.IsEmpty() )
	{
		TRACE(_T("No Filename defined for Encoding!\n"));
		return;
	}
	CString sData;
	//long nEncodeTextLen = m_reEncode.GetTextLength();
	m_reEncode.GetWindowText(sData);

	if( sData.IsEmpty() )
	{
		TRACE(_T("No data defined for Encoding!\n"));
		return;
	}

	 // Create the new WAV file
	HANDLE hFile = CreateFile(sSel, 
					GENERIC_READ|GENERIC_WRITE, 
					FILE_SHARE_READ|FILE_SHARE_WRITE,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL|SECURITY_ANONYMOUS,
					NULL);

	if( hFile == NULL || hFile == INVALID_HANDLE_VALUE )
	{
		DWORD dwError = GetLastError();
		CString sError;
		{
			LPVOID lpMsgBuf;
			::FormatMessage( 
					FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM | 
					FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					dwError,
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					(LPTSTR) &lpMsgBuf,
					0,
					NULL 
			);
			sError = (LPCTSTR)lpMsgBuf;
			LocalFree( lpMsgBuf );  // Free the buffer.
		}
		sSel = sSel + _T(" : ") + sError;
		TRACE(sSel+_T("\n"));
		AfxMessageBox(sSel, MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	 // Set up all the data
	WAVEFORMATEX	wf;
	DWORD dwPosSizeAll = 4;
	DWORD dwPosSizeData = 0;
	DWORD dwSize, dwWritten;

	wf.cbSize = 0;
	wf.wFormatTag = WAVE_FORMAT_PCM;
	wf.nSamplesPerSec = 8000; //(DWORD)floor(fFrequency);
	wf.wBitsPerSample = 16;
	wf.nChannels = 1;
	wf.nBlockAlign = (wf.wBitsPerSample * wf.nChannels)/8;
	wf.nAvgBytesPerSec = wf.nSamplesPerSec * wf.nBlockAlign;

	 // Write out the header
	dwSize = MAKEFOURCC('R','I','F','F');
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	dwPosSizeAll = GetFileSize(hFile, NULL);
	dwSize = 8 + sizeof(wf);
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	dwSize = MAKEFOURCC('W','A','V','E');
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	dwSize = MAKEFOURCC('f','m','t',' ');
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	dwSize = sizeof(wf);
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	WriteFile(hFile, &wf, sizeof(wf), &dwWritten, NULL);
	dwSize = MAKEFOURCC('d','a','t','a');
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	dwPosSizeData = GetFileSize(hFile, NULL);
	dwSize = 0;
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);

	// Where am I?
	DWORD dwStart = GetFileSize(hFile, NULL);

	m_pcEncode.SetRange(0, sData.GetLength()+7);
	// Add the new stuff
	short *pData = new short[wf.nAvgBytesPerSec];
	TCHAR c;
	int nSize;
	DWORD dwLength = 0;
	 // Add in some startup diddle (2 sec should be enough)
	for(c = 0; c < 2; ++c)
	{
		m_pcEncode.SetPos(dwLength++);
		nSize = pGetHHTwiddle(pData, wf.nAvgBytesPerSec);
		WriteFile(hFile, pData, nSize*sizeof(short), &dwWritten, NULL);
		dwStart += nSize*sizeof(short);
	}

	while( !sData.IsEmpty() )
	{
		m_pcEncode.SetPos(dwLength++);
		c = sData.GetAt(0);
		sData = sData.Mid(1);
		if( pEncodeHHDataW )
		{
			nSize = pEncodeHHDataW(pData, wf.nAvgBytesPerSec, (LPWSTR)&c, 1);
		}
		else
		{
			CHAR c2 = (CHAR)c;
			nSize = pEncodeHHDataA(pData, wf.nAvgBytesPerSec, (LPSTR)&c2, 1);
		}
		WriteFile(hFile, pData, nSize*sizeof(short), &dwWritten, NULL);
		dwStart += nSize*sizeof(short);
	}
	 // Add in some cleanup diddle (5 sec should be enough)
	for(c = 0; c < 5; ++c)
	{
		m_pcEncode.SetPos(dwLength++);
		nSize = pGetHHTwiddle(pData, wf.nAvgBytesPerSec);
		WriteFile(hFile, pData, nSize*sizeof(short), &dwWritten, NULL);
		dwStart += nSize*sizeof(short);
	}

	delete [] pData;

	// Save the new chunk size into the header
	SetFilePointer(hFile, dwPosSizeAll, NULL, FILE_BEGIN);
	dwSize = dwStart - sizeof(DWORD)*2;
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	// Save the new data size into the header
	SetFilePointer(hFile, dwPosSizeData, NULL, FILE_BEGIN);
	dwSize = dwStart - dwPosSizeData;
	WriteFile(hFile, &dwSize, sizeof(DWORD), &dwWritten, NULL);
	// Zip to the end for the next chunk
	//SetFilePointer(hFile, dwStart, NULL, FILE_BEGIN);
	CloseHandle(hFile);
}

void CHHTRXDlg::OnBnClickedButtonDecode()
{
	// Check for bad pointers
	if( !pDecodeHHDataA && !pDecodeHHDataW )
	{
		TRACE(_T("No Function defined for Decoding!\n"));
		return;
	}
	CString sSel;
	m_editDecodeFile.GetWindowText(sSel);
	if( sSel.IsEmpty() )
	{
		TRACE(_T("No Filename defined for Decoding!\n"));
		return;
	}

	 // Clean out the text control
	m_reDecode.SetWindowText(_T(""));

	 // Open the WAV file
	HANDLE hFile = CreateFile(sSel, 
					GENERIC_READ, 
					FILE_SHARE_READ,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL|SECURITY_ANONYMOUS,
					NULL);

	if( hFile == NULL || hFile == INVALID_HANDLE_VALUE )
	{
		DWORD dwError = GetLastError();
		CString sError;
		{
			LPVOID lpMsgBuf;
			::FormatMessage( 
					FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM | 
					FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					dwError,
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					(LPTSTR) &lpMsgBuf,
					0,
					NULL 
			);
			sError = (LPCTSTR)lpMsgBuf;
			LocalFree( lpMsgBuf );  // Free the buffer.
		}
		sSel = sSel + _T(" : ") + sError;
		TRACE(sSel+_T("\n"));
		AfxMessageBox(sSel, MB_OK|MB_ICONEXCLAMATION);
		return;
	}

#define SAMPLES_PER_SECOND	8000
	DWORD dwRead, dwSize, dwTmp, dwLabel;
	WORD  wTmp;
	WAVEFORMATEX	wf;
	short pData[SAMPLES_PER_SECOND];

	 // Load in the header
	dwLabel = MAKEFOURCC('R','I','F','F');
	ReadFile(hFile, &dwTmp, sizeof(dwTmp), &dwRead, NULL);
	if( dwLabel != dwTmp )
	{
		TRACE(_T("Fatal Error: Invalid Wave file\n"));
		return;
	}
	else
	{
		// Get the RIFF header chunk size
		ReadFile(hFile, &dwSize, sizeof(dwSize), &dwRead, NULL);
		if( dwRead )
		{
			// WAVE
			ReadFile(hFile, &dwLabel, sizeof(dwLabel), &dwRead, NULL);
			if( dwLabel == MAKEFOURCC('W','A','V','E') )
			{
				 // Loop through the WAVE chunk
				for(;;)
				{
					// Label
					ReadFile(hFile, &dwLabel, sizeof(dwLabel), &dwRead, NULL);
					if( dwRead )
					{
						// Size
						ReadFile(hFile, &dwSize, sizeof(dwSize), &dwRead, NULL);

						if( dwLabel == MAKEFOURCC('f','m','t',' ') )
						{
							// Read the wave header
							// Type
							ReadFile(hFile, &wTmp, sizeof(WORD), &dwRead, NULL);
							dwSize -= dwRead;
							wf.wFormatTag = 1;
							if( wTmp != 1 )
							{
								MessageBox(_T("Not a PCM file!"), NULL, MB_OK);
								goto Fini;
							}
							// Channels
							ReadFile(hFile, &wTmp, sizeof(WORD), &dwRead, NULL);
							dwSize -= dwRead;
							wf.nChannels = 1;
							if( wTmp != 1 )
							{
								MessageBox(_T("Not a Mono file!"), NULL, MB_OK);
								goto Fini;
							}
							// Sample Rate
							ReadFile(hFile, &dwTmp, sizeof(DWORD), &dwRead, NULL);
							dwSize -= dwRead;
							wf.nSamplesPerSec = dwTmp;
							if( dwTmp != 8000 )
							{
								MessageBox(_T("Not a 8000 Hz file!"), NULL, MB_OK);
								goto Fini;
							}
							// Byte Rate
							ReadFile(hFile, &dwTmp, sizeof(DWORD), &dwRead, NULL);
							dwSize -= dwRead;
							wf.nAvgBytesPerSec = dwTmp;
							// Block Align
							ReadFile(hFile, &wTmp, sizeof(WORD), &dwRead, NULL);
							dwSize -= dwRead;
							wf.nBlockAlign = wTmp;
							// Bits
							ReadFile(hFile, &wTmp, sizeof(WORD), &dwRead, NULL);
							dwSize -= dwRead;
							wf.wBitsPerSample = wTmp;
							if( wTmp != 16 )
							{
								MessageBox(_T("Not a 16-bit file!"), NULL, MB_OK);
								goto Fini;
							}
							ASSERT(SAMPLES_PER_SECOND >= dwSize);
							ReadFile(hFile, pData, dwSize, &dwRead, NULL);

							wf.nBlockAlign = (wf.wBitsPerSample * wf.nChannels)/8;
							wf.nAvgBytesPerSec = wf.nSamplesPerSec * wf.nBlockAlign;
						}
						else if( dwLabel == MAKEFOURCC('d','a','t','a') )
						{
							m_pcDecode.SetRange32(0, dwSize+16000);
							DWORD dwTotalSize = dwSize;
							char szText[4096];
							WCHAR szwText[4096];
							CString sText;
							long nLen = m_reDecode.GetTextLength();
							int nSize;

							while( dwSize > 0 )
							{
								DWORD dwLeft = dwSize;
								if( dwLeft > SAMPLES_PER_SECOND*sizeof(short) )
									dwLeft = SAMPLES_PER_SECOND*sizeof(short);
								 // Read in the "data"
								ReadFile(hFile, pData, dwLeft, &dwRead, NULL);
								if( dwRead == 0 ) break;
								dwSize -= dwRead;
								m_pcDecode.SetPos(dwTotalSize-dwSize);
								 // Decode the data
								if( pDecodeHHDataW )
								{
									nSize = pDecodeHHDataW(pData, dwRead/sizeof(short), szwText, sizeof(szwText)/sizeof(WCHAR));
									szwText[nSize] = '\0';
									sText = szwText;
								}
								else
								{
									nSize = pDecodeHHDataA(pData, dwRead/sizeof(short), szText, sizeof(szText));
									szText[nSize] = '\0';
									sText = szText;
								}
								if( nSize > 0 )
								{
									m_reDecode.SetSel(nLen, nLen);
									m_reDecode.ReplaceSel(sText);
									nLen += (long)sText.GetLength();
								}

								 // Make sure that windows doesn't hang
								MSG msg;
								if( ::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) )
								{
									if( msg.message == WM_QUIT ) goto Fini;
									::TranslateMessage(&msg);
									::DispatchMessage(&msg);
								}
							}
							 // Pump out any remaining data
							for(;;)
							{
								dwSize += 48000;
								m_pcDecode.SetPos(dwTotalSize+dwSize);
								if( pDecodeHHDataW )
								{
									nSize = pDecodeHHDataW(NULL, 0, szwText, sizeof(szwText)/sizeof(WCHAR));
									szwText[nSize] = '\0';
									sText = szwText;
								}
								else
								{
									nSize = pDecodeHHDataA(NULL, 0, szText, sizeof(szText));
									szText[nSize] = '\0';
									sText = szText;
								}
								if( nSize > 0 )
								{
									m_reDecode.SetSel(nLen, nLen);
									m_reDecode.ReplaceSel(sText);
									nLen += (long)sText.GetLength();
								}
								else
									break;

								 // Make sure that windows doesn't hang
								MSG msg;
								if( ::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) )
								{
									if( msg.message == WM_QUIT ) goto Fini;
									::TranslateMessage(&msg);
									::DispatchMessage(&msg);
								}
							}
							m_pcDecode.SetPos(dwTotalSize+16000);
						}
						 // Undefined chunks
						else
						{
							while( dwSize > SAMPLES_PER_SECOND )
							{
								ReadFile(hFile, pData, SAMPLES_PER_SECOND, &dwRead, NULL);
								dwSize -= dwRead;
								if( dwRead < SAMPLES_PER_SECOND )
								{
									TRACE(_T("Fatal Error: Premature EOF 3 found in Label \"%c%c%c%c\" - Wanted %ld, got %ld\n"), 
										dwLabel&0xFF, 
										(dwLabel>>8)&0xFF,
										(dwLabel>>16)&0xFF,
										(dwLabel>>24)&0xFF, 
										SAMPLES_PER_SECOND, dwRead
										);
									goto Fini;
								}
							}
							if( dwSize > 0 )
							{
								ReadFile(hFile, pData, dwSize, &dwRead, NULL);
								if( dwRead < dwSize )
								{
									TRACE(_T("Fatal Error: Premature EOF 3 found in Label \"%c%c%c%c\" - Wanted %ld, got %ld\n"), 
										dwLabel&0xFF, 
										(dwLabel>>8)&0xFF,
										(dwLabel>>16)&0xFF,
										(dwLabel>>24)&0xFF, 
										dwSize, dwRead
										);
									goto Fini;
								}
							}
						}
					} // Read Label
					else
						break;
				} // for(;;)
			} // WAVE
			else
			{
				AfxMessageBox(_T("Not a WAVE file!"), MB_OK);
			}
		}// Read header
	}
Fini:
	CloseHandle(hFile);
}

