// HHTRXDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "HHSnapIn.h"

typedef int (WINAPI GETHHTWIDDLE)(short *sData, int cbLen);
typedef double (WINAPI GETHHINTERNALFREQUENCY)(void);
typedef int (WINAPI ENCODEHHDATAA)(short *sData, int cbLen, LPSTR lpStr, int cbStr);
typedef int (WINAPI DECODEHHDATAA)(short *sData, int cbLen, LPSTR lpStr, int cbStr);
typedef int (WINAPI ENCODEHHDATAW)(short *sData, int cbLen, LPWSTR lpwStr, int cbStr);
typedef int (WINAPI DECODEHHDATAW)(short *sData, int cbLen, LPWSTR lpwStr, int cbStr);
typedef UINT (WINAPI INVOKEHHSETUP)(HWND hWndParent);
typedef UINT (WINAPI INVOKEHHFUNC)(HWND hWndParent, WPARAM wParam, LPARAM lParam);
typedef UINT (WINAPI INVOKEHHSETUP)(HWND hWndParent);
typedef HWND (WINAPI GETHHTOOLBAR)(HWND hWndParent, DWORD dwTBStyle, UINT wID);
typedef BOOL (WINAPI DOHHCOMMAND)(UINT command);
typedef BOOL (WINAPI LOADHHUSERDATA)(LPVOID lpData, UINT cbData);
typedef BOOL (WINAPI SAVEHHUSERDATA)(LPVOID lpData, UINT cbData);

// CHHTRXDlg dialog
class CHHTRXDlg : public CDialog
{
// Construction
public:
	CHHTRXDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CHHTRXDlg();

// Dialog Data
	enum { IDD = IDD_HHTRX_DIALOG };

	class SnapIn: public CObject
	{
	public:
		SnapIn() 
		{ 
			ZeroMemory(&m_sisSettings, sizeof(SNAPINSETUP));
			m_sisSettings.m_cbSize = sizeof(SNAPINSETUP); 
		}

	public:
		TCHAR		m_szFilename[MAX_PATH];
		TCHAR		m_szName[256];
		SNAPINSETUP	m_sisSettings;
	};

	CObList m_SnapinList;
	GETHHINTERNALFREQUENCY *pGetHHInternalFrequency;
	GETHHTWIDDLE *pGetHHTwiddle;
	ENCODEHHDATAA *pEncodeHHDataA;
	DECODEHHDATAA *pDecodeHHDataA;
	ENCODEHHDATAW *pEncodeHHDataW;
	DECODEHHDATAW *pDecodeHHDataW;
	GETHHTOOLBAR *pGetHHToolbar;
	DOHHCOMMAND *pDoHHCommand;
	LOADHHUSERDATA *pLoadHHUserData;
	SAVEHHUSERDATA *pSaveHHUserData;
	INVOKEHHSETUP *pInvokeHHSetup;

	HMODULE	m_hMode;

	CToolBar	m_tbToolbar;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CComboBox m_cbModule;
	afx_msg void OnCbnSelchangeComboModule();
	afx_msg void OnBnClickedButtonSetup();
	CEdit m_editEncodeFile;
	CEdit m_editDecodeFile;
	afx_msg void OnBnClickedButtonEncodeFile();
	afx_msg void OnBnClickedButtonDecodeFile();
	CRichEditCtrl m_reEncode;
	CRichEditCtrl m_reDecode;
	afx_msg void OnBnClickedButtonEncode();
	afx_msg void OnBnClickedButtonDecode();
	afx_msg void OnClose();
protected:
	virtual void OnCancel();
public:
	void Cleanup(void);
	CProgressCtrl m_pcEncode;
	CProgressCtrl m_pcDecode;
protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
};
