// Setup.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Setup.h"
#include ".\setup.h"
#include "AboutDlg.h"

// Setup dialog

IMPLEMENT_DYNAMIC(CSetup, CDialog)

CSetup::CSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CSetup::IDD, pParent)
	, m_fFSC(0)
	, m_radioInterleave(FALSE)
	, m_nIntegration(0)
	, m_radioBandwidth(FALSE)
	, m_fSNR(0)
	, m_fConf(0)
	, m_fAmp(0)
	, m_bFilterRXInteg(false)
{
}

CSetup::~CSetup()
{
}

void CSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_FSC_EDIT, m_fFSC);
	DDX_Radio(pDX, IDC_INTERLEAVE_SHORT_RADIO, m_radioInterleave);
	DDX_Text(pDX, IDC_INTEGRATION_EDIT, m_nIntegration);
	DDX_Radio(pDX, IDC_BANDWIDTH_500_RADIO, m_radioBandwidth);
	DDX_Text(pDX, IDC_SNR_EDIT, m_fSNR);
	DDX_Text(pDX, IDC_CONF_EDIT, m_fConf);
	DDX_Control(pDX, IDC_SLIDER_AMP, m_scAmp);
	DDX_Control(pDX, IDC_CHECK_FILTERRX, m_buttonFilter);
}

BEGIN_MESSAGE_MAP(CSetup, CDialog)
	ON_BN_CLICKED(IDC_ABOUT, OnBnClickedAbout)
	ON_WM_VSCROLL()
END_MESSAGE_MAP()

// Setup message handlers

BOOL CSetup::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here

	m_scAmp.SetRange(0, 8);
	//pSC->SetLineSize(1);
	int nVal;
	if( m_fAmp > 1 )
		nVal = m_fAmp/6.0;
	else if( m_fAmp == 1 )
		nVal = 0;
	else
		nVal = m_fAmp*6.0;

	m_scAmp.SetPos(nVal+4);

	TRACE(_T("Setting amp bar to %d\n"), nVal);

	m_buttonFilter.SetCheck(m_bFilterRXInteg);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSetup::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class

	UpdateData(TRUE);

	if( m_fFSC < 7900 ) m_fFSC = 7900;
	if( m_fFSC > 8100 ) m_fFSC = 8100;

	int nVal;

	nVal = m_scAmp.GetPos()-4;
	if( nVal > 0 )
		m_fAmp = nVal*6.0;
	else if( nVal == 0 )
		m_fAmp = 1.0;
	else 
		m_fAmp = nVal/6.0;

	TRACE(_T("Got amp bar at %d\n"), nVal);

	m_bFilterRXInteg = m_buttonFilter.GetCheck()==TRUE;

	CDialog::OnOK();
}

void CSetup::OnBnClickedAbout()
{
	CAboutDlg	about(this);

	about.DoModal();
}


void CSetup::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}
